﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sparrow.Web.Router;

namespace Sparrow.CMS
{
    public interface IPageContentProvider
    {
        IQueryable<PageContent> PageContents();

        PageContent FindContent(WebRouter router, string culture);

        bool AddContent(WebRouter router, PageContent pageContent);
        bool UpdateContent(WebRouter router, PageContent pageContent);
        bool RemoveContent(WebRouter router, PageContent pageContent);

        IEnumerable<string> GetActionNames(PageContent content, Widget widget);

        bool AddAction(PageContent content, Widget widget, string actionName);

        bool RemoveAction(PageContent content, Widget widget, string actionName);
    }
}
