﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Sparrow.Reflection
{
    public class FieldProxy
    {
        public FieldProxy(object instance)
        {
            this.Instance = instance;
        }

        object Instance
        {
            get;
            set;
        }


        public object this[string name]
        {
            get
            {
                var getter = Instance.Metadata().Fields[name];
                if (getter != null)
                {
                    return getter.GetValue(this.Instance);
                }
                return null;
            }
            set
            {
                //can NOT assign a new value to a method by reflection
            }
        }
    }
}
