﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Sparrow.Tests.IoC
{

    using Sparrow.IoC;
      
    [TestClass]
    public class ObjectFactoryTests
    {
        class Mock
        {
            public Mock()
            {
            }
        }

        class NotSupported
        {
            public NotSupported(string name)
            {
            }
        }

        [TestMethod]
        public void should_return_an_instance_of_the_type()
        {
            var factory = new ObjectFactory();
            var actual = factory.CreateInstance(typeof(Mock));
            Assert.IsInstanceOfType(actual, typeof(Mock));
        }

        [TestMethod]
        [ExpectedException(typeof(NotSupportedException))]
        public void should_thorw_a_not_support_exception_when_the_type_has_not_a_public_parameterless_contructor()
        {
            var factory = new ObjectFactory();
            factory.CreateInstance(typeof(NotSupported));
        }
    }
}
